using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UIElements;

public class BallMovement : MonoBehaviour
{
    public Transform target;
    public Transform player;
    public Vector3 moveDirection;
    
    private float zmin = 0;
    private float zmax = 0;
    private float zScaleEmitter = 0;
    private float zScaleTarget = 0;
    
    // Start is called before the first frame update
    void Start()
    {
        zScaleEmitter = transform.localScale.z / 2;

        transform.rotation = target.transform.rotation;
        transform.position = target.transform.position;
        
        moveDirection.x = target.transform.position.x;
        moveDirection.y = target.transform.position.y;
        transform.SetParent(target.transform);
        
        zScaleTarget = target.localScale.z / 2;
        
        zmin = (target.position.z - zScaleTarget) + zScaleEmitter;
        zmax = (target.transform.position.z + zScaleTarget) - zScaleEmitter;
        
        
    }

    // Update is called once per frame
    void FixedUpdate()
    {
        moveDirection.z = Mathf.Clamp(player.transform.position.z, zmin,zmax);
        transform.position = moveDirection;

    }
}
