# ![Orientation](images/icons/HandleAlign_Local.png) Orientation

The __Orientation__ action sets the orientation of scene handles when you select [objects and elements](modes.md). Click the __Orientation__ button to switch between the three states: __Global__, __Local__, or __Normal__.

![Handle Orientation Examples](images/HandleAlign_ExamplesWithTextAndIcons.png)

Depending whether you are in [text mode or icon mode](toolbar.md#buttonmode), the button displays the following to indicate what state the action is in:

| **Icon mode:**                                             | **Text mode:**            | **Description:**                                           |
| :----------------------------------------------------------- | ----------------------- | ------------------------------------------------------------ |
| ![Handle Alignment Global](images/icons/HandleAlign_World.png) | **Orientation: Global** | Similar to a compass, the handle orientation is always the same, regardless of local rotation. |
| ![Handle Alignment Local](images/icons/HandleAlign_Local.png) | **Orientation: Local**  | Similar to left vs right, handle orientation is relative to the object's rotation. |
| ![Handle Alignment Planar](images/icons/HandleAlign_Plane.png) | **Orientation: Normal** | Special mode that aligns the handles to the exact normal direction of the selected face. |

This action is available in all [edit modes](modes.md).

> **Tip:** You can also use this action with the **P** shortcut, or from the ProBuilder menu (**Tools** > **ProBuilder** > **Interaction** > **Toggle Handle Orientation**).
